                    !cpu 6510

DEBUG = 0
RELEASE = 1
; ==============================================================================
ENABLE              = 0x20
ENABLE_JMP          = 0x4C
DISABLE             = 0x2C

BLACK               = 0x00
WHITE               = 0x01
RED                 = 0x02
CYAN                = 0x03
PURPLE              = 0x04
GREEN               = 0x05
BLUE                = 0x06
YELLOW              = 0x07
ORANGE              = 0x08
BROWN               = 0x09
PINK                = 0x0A
DARK_GREY           = 0x0B
GREY                = 0x0C
LIGHT_GREEN         = 0x0D
LIGHT_BLUE          = 0x0E
LIGHT_GREY          = 0x0F

MEMCFG              = 0x35
; ------------------------------------------------------------------------------
;                   BADLINEs (0xD011 default)
;                   -------------------------
;                   00 : 0x33
;                   01 : 0x3B
;                   02 : 0x43
;                   03 : 0x4B
;                   04 : 0x53
;                   05 : 0x5B
;                   06 : 0x63
;                   07 : 0x6B
;                   08 : 0x73
;                   09 : 0x7B
;                   10 : 0x83
;                   11 : 0x8B
;                   12 : 0x93
;                   13 : 0x9B
;                   14 : 0xA3
;                   15 : 0xAB
;                   16 : 0xB3
;                   17 : 0xBB
;                   18 : 0xC3
;                   19 : 0xCB
;                   20 : 0xD3
;                   21 : 0xDB
;                   22 : 0xE3
;                   23 : 0xEB
;                   24 : 0xF3
; ------------------------------------------------------------------------------
IRQ_LINE0           = 0xFA
IRQ_LINE1           = 0xA2
; ==============================================================================
zp_start            = 0x02
flag_irq_ready      = zp_start

; ==============================================================================
KEY_CRSRUP          = 0x91
KEY_CRSRDOWN        = 0x11
KEY_CRSRLEFT        = 0x9D
KEY_CRSRRIGHT       = 0x1D
KEY_RETURN          = 0x0D
KEY_STOP            = 0x03

getin               = 0xFFE4
keyscan             = 0xEA87
; ==============================================================================
code_start          = 0x0800
vicbank0            = 0x0000
charset0            = vicbank0+0x2800
charset1            = vicbank0+0x1800
vidmem0             = vicbank0+0x2400
data_start          = 0x3400
music_init          = 0x1000
music_play          = 0x1003

BD_SCAN             = 0x13D5
BD_VAL              = 0x43

SD_SCAN             = 0x13BA
SD_VAL              = 0x18

sprite_data         = vicbank0+0x3000
sprite_base         = <((sprite_data-vicbank0)/0x40)
sprite_base_end     = sprite_base+15
dd00_val0           = <!(vicbank0/0x4000) & 3
d018_val0           = <(((vidmem0-vicbank0)/0x400) << 4)+ <(((charset0-vicbank0)/0x800) << 1)
d018_val1           = <(((vidmem0-vicbank0)/0x400) << 4)+ <(((charset1-vicbank0)/0x800) << 1)
; ==============================================================================
                    !macro flag_set .flag {
                        lda #1
                        sta .flag
                    }
                    !macro flag_clear .flag {
                        lda #0
                        sta .flag
                    }
                    !macro flag_get .flag {
                        lda .flag
                    }
; ==============================================================================
                    *= vidmem0
;     0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15  16  17  18  19  20  21  22  23  24  25  26  27  28  29  30  31  32  33  34  35  36  37  38  39
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 0
!by $00,$00,$00,$01,$02,$03,$04,$05,$06,$06,$06,$06,$06,$06,$07,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$02,$00,$00,$00
!by $00,$00,$00,$08,$09,$0A,$0B,$0C,$0D,$0D,$0D,$0D,$0D,$0D,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11,$12,$00,$00,$00
!by $00,$00,$00,$08,$09,$0F,$10,$0C,$0D,$0D,$0D,$0D,$0D,$0D,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$11,$12,$13,$00,$14,$15,$15,$15,$15,$15,$15,$16,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$17,$1F,$20,$21,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 5
!by $00,$00,$00,$22,$0B,$23,$24,$25,$26,$0A,$27,$22,$28,$29,$2A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$01,$02,$2B,$2C,$05,$06,$06,$06,$06,$06,$06,$07,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$08,$09,$2D,$2E,$0C,$0D,$0D,$0D,$0D,$0D,$0D,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$08,$09,$0F,$2F,$0C,$0D,$0D,$0D,$0D,$0D,$0D,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$08,$09,$29,$2A,$0C,$0D,$0D,$0D,$0D,$0D,$0D,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 10
!by $00,$00,$00,$08,$09,$0F,$10,$0C,$0D,$0D,$0D,$30,$31,$32,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$02,$00,$00,$00
!by $00,$00,$00,$11,$12,$34,$35,$14,$15,$15,$15,$36,$37,$38,$39,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11,$12,$00,$00,$00
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
!by $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20 ; 15
!by $20,$20,$20,$44,$09,$05,$20,$48,$0F,$13,$05,$20,$0B,$0C,$05,$0D,$0D,$14,$2C,$20,$0D,$05,$09,$0E,$20,$48,$0F,$04,$05,$0E,$20,$02,$12,$05,$0E,$0E,$14,$20,$20,$20
!by $20,$20,$20,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$20,$20,$20
!by $20,$20,$20,$55,$53,$45,$20,$38,$35,$38,$30,$21,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$30,$30,$3A,$30,$30,$20,$2F,$20,$30,$34,$3A,$32,$35,$20,$20,$20
!by $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
!by $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20 ; 20
!by $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
!by $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
!by $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
!by $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
;     0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15  16  17  18  19  20  21  22  23  24  25  26  27  28  29  30  31  32  33  34  35  36  37  38  39
; ==============================================================================
                    *= music_init
                    !bin "../sid/Die_Hose_klemmt_mein_Hoden_brennt.sid",,0x7E
; ==============================================================================
                    *= code_start
                    lda #0x7F
                    sta 0xDC0D
                    lda #MEMCFG
                    sta 0x01
                    lda #0x0B
                    sta 0xD011
                    jmp init_code
; ==============================================================================
                    !zone IRQ
                    NUM_IRQS = 0x02
irq:                !if MEMCFG = 0x35 {
                        sta .irq_savea+1
                        stx .irq_savex+1
                        sty .irq_savey+1
                        lda 0x01
                        sta .irq_save0x01+1
                        lda #0x35
                        sta 0x01
                    }
irq_next:           jmp irq0
irq_end:            lda 0xD012
-                   cmp 0xD012
                    beq -
.irq_index:         ldx #0
                    lda irq_tab_lo,x
                    sta irq_next+1
                    lda irq_tab_hi,x
                    sta irq_next+2
                    lda irq_lines,x
                    sta 0xD012
                    inc .irq_index+1
                    lda .irq_index+1
                    cmp #NUM_IRQS
                    bne +
                    lda #0
                    sta .irq_index+1
+                   asl 0xD019
                    !if MEMCFG = 0x37 {
                        jmp 0xEA31
                    }
                    !if MEMCFG = 0x36 {
                        jmp 0xEA81
                    }
                    !if MEMCFG = 0x35 {
.irq_save0x01:          lda #0x35
                        sta 0x01
                        cmp #0x36
                        beq +
.irq_savea:             lda #0
.irq_savex:             ldx #0
.irq_savey:             ldy #0
                        rti
+                       jmp 0xEA81
                    }

irq0:               +flag_set flag_irq_ready
                    ldx #2
-                   dex
                    bpl -
                    nop
                    lda #PURPLE
                    sta 0xD020
                    jsr music_play
                    lda #BLACK
                    sta 0xD020
                    sta 0xD021
                    lda #d018_val0
                    sta 0xD018
                    jsr anim_bd
                    jsr anim_sd
                    jsr timer_increase
                    jmp irq_end

irq1:               ldx #1
-                   dex
                    bpl -
                    lda #0x1B
                    sta 0xD011
                    lda #d018_val1
                    sta 0xD018
                    lda #BLUE
                    sta 0xD021
                    sta 0xD020
                    ldx #1
-                   dex
                    bpl -
                    lda #BLACK
                    sta 0xD021
                    sta 0xD020
                    ldx #9
-                   dex
                    bpl -
                    lda #BLUE
                    sta 0xD021
                    sta 0xD020
                    jsr anim_sprites
                    jsr anim_colors
                    jmp irq_end

irq_tab_lo:         !byte <irq0, <irq1
irq_tab_hi:         !byte >irq0, >irq1
irq_lines:          !byte IRQ_LINE0, IRQ_LINE1
; ==============================================================================
init_code:          jsr init_nmi
                    jsr init_vic
                    jsr init_music
                    jsr init_irq
                    jmp mainloop

init_irq:           lda irq_lines
                    sta 0xD012
                    lda #<irq
                    sta 0x0314
                    !if MEMCFG = 0x35 {
                        sta 0xFFFE
                    }
                    lda #>irq
                    sta 0x0315
                    !if MEMCFG = 0x35 {
                        sta 0xFFFF
                    }
                    lda #0x0B
                    sta 0xD011
                    lda #0x01
                    sta 0xD019
                    sta 0xD01A
                    rts

init_nmi:           lda #<nmi
                    sta 0x0318
                    !if MEMCFG = 0x35 {
                        sta 0xFFFA
                    }
                    lda #>nmi
                    sta 0x0319
                    !if MEMCFG = 0x35 {
                        sta 0xFFFB
                    }
                    rts

init_vic:
                    ldx #0
-                   lda colram_data+0x000,x
                    sta 0xD800+0x000,x
                    lda colram_data+0x100,x
                    sta 0xD800+0x100,x
                    lda colram_data+0x200,x
                    sta 0xD800+0x200,x
                    lda colram_data+0x2e8,x
                    sta 0xD800+0x2e8,x
                    inx
                    bne -

                    lda #BLACK
                    sta 0xD020
                    sta 0xD021

                    lda #dd00_val0
                    sta 0xDD00
                    lda #d018_val0
                    sta 0xD018

                    lda #sprite_base
                    sta vidmem0+0x3F8

                    lda #0x5B
                    sta 0xD000
                    lda #0x80
                    sta 0xD001

                    lda #WHITE
                    sta 0xD027

                    lda #LIGHT_GREY
                    sta 0xD025
                    lda #YELLOW
                    sta 0xD026

                    lda #0
                    sta 0xD017

                    lda #%00000001
                    sta 0xD01B
                    sta 0xD01C
                    sta 0xD01D

                    sta 0xD015
                    rts

init_music:         lda #0
                    jsr music_init
                    rts
; ==============================================================================
                    !zone MAINLOOP
mainloop:           jsr wait_irq
                    jsr anim_quatsch
                    jmp mainloop
; ==============================================================================
                    !zone NMI
nmi:                lda #0x37               ; restore 0x01 standard value
                    sta 0x01
                    lda #0                  ; if AR/RR present
                    sta 0xDE00              ; reset will lead to menu
                    jmp 0xFCE2              ; reset
; ==============================================================================
                    !zone WAIT
wait_irq:           +flag_clear flag_irq_ready
.wait_irq:          +flag_get flag_irq_ready
                    beq .wait_irq
                    rts
; ==============================================================================
                    !zone TIMER
timer_increase:     min_cnt_hi = vidmem0+(18*40)+24+0
                    min_cnt_lo = vidmem0+(18*40)+24+1
                    sec_cnt_hi = vidmem0+(18*40)+24+3
                    sec_cnt_lo = vidmem0+(18*40)+24+4
                    dec framecounter
                    beq +
                    rts
+                   lda sec_cnt_lo
                    cmp #0x39
                    bne ++++
                    lda #0x2F
                    sta sec_cnt_lo
                    lda sec_cnt_hi
                    cmp #0x35
                    bne +++
                    lda #0x2F
                    sta sec_cnt_hi
                    lda min_cnt_lo
                    cmp #0x39
                    bne ++
                    lda #0x2F
                    sta min_cnt_lo
                    lda min_cnt_hi
                    cmp #0x35
                    bne +
                    lda #0x2F
                    sta min_cnt_hi
+                   inc min_cnt_hi
++                  inc min_cnt_lo
+++                 inc sec_cnt_hi
++++                inc sec_cnt_lo
                    lda #50
                    sta framecounter
                    rts
framecounter:       !byte 50
min_end_hi:         !byte 0x00
min_end_lo:         !byte 0x00
sec_end_hi:         !byte 0x00
sec_end_lo:         !byte 0x00
; ==============================================================================
                    !zone ANIMATION
anim_bd:            lda BD_SCAN
                    cmp #BD_VAL
                    bne +
                    lda #WHITE
                    !byte 0x2C
+                   lda #PINK
                    sta 0xD800+(1*40)+35
                    sta 0xD800+(1*40)+36
                    sta 0xD800+(2*40)+35
                    sta 0xD800+(2*40)+36
                    rts

anim_sd:            lda SD_SCAN
                    cmp #SD_VAL
                    bne +
                    lda #WHITE
                    !byte 0x2C
+                   lda #PINK
                    sta 0xD800+(11*40)+35
                    sta 0xD800+(11*40)+36
                    sta 0xD800+(12*40)+35
                    sta 0xD800+(12*40)+36
                    rts
                    ANIM_QUATSCH_SPEED = 3
anim_quatsch:       lda #ANIM_QUATSCH_SPEED
                    beq +
                    dec anim_quatsch+1
                    rts
+                   lda #ANIM_QUATSCH_SPEED
                    sta anim_quatsch+1
                    ldx #33
.mod:               lda 0x1385,x
                    sta vidmem0+(23*40)+3,x
                    dex
                    bpl .mod
                    inc .mod+1
                    lda .mod+1
                    cmp #0xBB
                    bne +
                    lda #<(0x1385)
                    sta .mod+1
+                   rts

                    ANIM_SPRITE_SPEED = 2
anim_sprites:       lda #ANIM_SPRITE_SPEED
                    beq +
                    dec anim_sprites+1
                    rts
+                   lda #ANIM_SPRITE_SPEED
                    sta anim_sprites+1
.swincdec:          inc vidmem0+0x3F8
                    lda vidmem0+0x3F8
.swcmp:             cmp #sprite_base_end
                    bne +
                    lda #sprite_base
                    sta vidmem0+0x3F8
+                   rts

                    ANIM_COLORS_SPEED = 1
anim_colors:        lda #0xFF
                    beq +
                    dec anim_colors+1
                    rts
+                   lda #ANIM_COLORS_SPEED
                    sta anim_colors+1

.colindex:          ldx #0
                    lda coltab0,x
                    sta 0xD800+(1*40)+3
                    sta 0xD800+(1*40)+4
                    !for i, 7, 14 {
                        sta 0xD800+(1*40)+i
                    }
                    inx
                    lda coltab0,x
                    sta 0xD800+(2*40)+3
                    sta 0xD800+(2*40)+4
                    !for i, 7, 14 {
                        sta 0xD800+(2*40)+i
                    }
                    inx
                    lda coltab0,x
                    sta 0xD800+(3*40)+3
                    sta 0xD800+(3*40)+4
                    !for i, 7, 14 {
                        sta 0xD800+(3*40)+i
                    }
                    inx
                    lda coltab0,x
                    sta 0xD800+(4*40)+3
                    sta 0xD800+(4*40)+4
                    !for i, 7, 14 {
                        sta 0xD800+(4*40)+i
                    }
                    inx
                    lda coltab0,x
                    sta 0xD800+(7*40)+3
                    sta 0xD800+(7*40)+4
                    !for i, 7, 14 {
                        sta 0xD800+(7*40)+i
                    }
                    inx
                    lda coltab0,x
                    sta 0xD800+(8*40)+3
                    sta 0xD800+(8*40)+4
                    !for i, 7, 14 {
                        sta 0xD800+(8*40)+i
                    }
                    inx
                    lda coltab0,x
                    sta 0xD800+(9*40)+3
                    sta 0xD800+(9*40)+4
                    !for i, 7, 14 {
                        sta 0xD800+(9*40)+i
                    }
                    inx
                    lda coltab0,x
                    sta 0xD800+(10*40)+3
                    sta 0xD800+(10*40)+4
                    !for i, 7, 14 {
                        sta 0xD800+(10*40)+i
                    }
                    inx
                    lda coltab0,x
                    sta 0xD800+(11*40)+3
                    sta 0xD800+(11*40)+4
                    !for i, 7, 14 {
                        sta 0xD800+(11*40)+i
                    }
                    inx
                    lda coltab0,x
                    sta 0xD800+(12*40)+3
                    sta 0xD800+(12*40)+4
                    !for i, 7, 14 {
                        sta 0xD800+(12*40)+i
                    }
                    dec .colindex+1
                    rts
code_end:
; ==============================================================================
                    *= charset0
charset_data:
    !byte $00,$00,$00,$00,$00,$00,$00,$00,$2F,$00,$2F,$2F,$2F,$2F,$2F,$2F
    !byte $FD,$00,$FD,$FD,$FD,$FD,$FD,$FD,$0F,$1F,$3E,$3C,$3C,$3E,$1F,$0F
    !byte $F0,$F8,$7C,$3C,$00,$00,$F0,$F8,$BF,$00,$BF,$BF,$BF,$BF,$BF,$BF
    !byte $FF,$00,$FF,$FF,$FF,$FF,$FF,$FF,$F4,$00,$F4,$F4,$F4,$F4,$F4,$F4
    !byte $2F,$2F,$2F,$2F,$2F,$2F,$2F,$2F,$FD,$FD,$FD,$FD,$FD,$FD,$FD,$FD
    !byte $00,$00,$3C,$3E,$1F,$0F,$00,$00,$7C,$3C,$3C,$7C,$F8,$F0,$00,$00
    !byte $BF,$BF,$BF,$BF,$BF,$BF,$BF,$BF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
    !byte $F4,$F4,$F4,$F4,$F4,$F4,$F4,$F4,$3F,$3F,$3C,$3C,$3C,$3C,$3F,$3F
    !byte $F0,$F8,$7C,$3C,$3C,$7C,$F8,$F0,$2F,$2F,$2F,$2F,$00,$2F,$00,$00
    !byte $FD,$FD,$FD,$FD,$00,$FD,$00,$00,$3C,$3C,$3C,$3C,$3C,$3C,$00,$00
    !byte $BF,$BF,$BF,$BF,$00,$BF,$00,$00,$FF,$FF,$FF,$FF,$00,$FF,$00,$00
    !byte $F4,$F4,$F4,$F4,$00,$F4,$00,$00,$0F,$1F,$3E,$3C,$3C,$3C,$3C,$3C
    !byte $F0,$F8,$7C,$3C,$00,$00,$FC,$FC,$0F,$0F,$03,$03,$03,$03,$03,$03
    !byte $F0,$F0,$C0,$C0,$C0,$C0,$C0,$C0,$00,$00,$00,$00,$00,$00,$00,$3F
    !byte $00,$00,$00,$00,$00,$00,$00,$FC,$03,$03,$00,$00,$00,$00,$00,$00
    !byte $FC,$FC,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F8,$7C,$3C,$3C,$3C,$3C,$3C
    !byte $3F,$3F,$3C,$3C,$3C,$3C,$3F,$3F,$FC,$FC,$00,$00,$00,$00,$C0,$C0
    !byte $3C,$3C,$3C,$3E,$1F,$0F,$00,$00,$03,$03,$03,$03,$0F,$0F,$00,$00
    !byte $C0,$C0,$C0,$C0,$F0,$F0,$00,$00,$3F,$00,$00,$00,$00,$00,$00,$00
    !byte $FC,$00,$00,$00,$00,$00,$00,$00,$F0,$F0,$F0,$F0,$E0,$C0,$00,$00
    !byte $3C,$3C,$3C,$7C,$F8,$F0,$00,$00,$3C,$3C,$3C,$3C,$3F,$3F,$00,$00
    !byte $00,$00,$00,$00,$FC,$FC,$00,$00,$3F,$3F,$3D,$3C,$3C,$3C,$3C,$3C
    !byte $C0,$E0,$F0,$F8,$7C,$3C,$3C,$3C,$3C,$3C,$3C,$3D,$3F,$3F,$00,$00
    !byte $3C,$7C,$F8,$F0,$E0,$C0,$00,$00,$FC,$FC,$00,$00,$00,$00,$C0,$C0
    !byte $FF,$FF,$F1,$F2,$F2,$F2,$F3,$F3,$FF,$FF,$32,$92,$92,$98,$9E,$9E
    !byte $FF,$FF,$43,$49,$4C,$4C,$4C,$4C,$F4,$F4,$94,$94,$94,$94,$94,$94
    !byte $3F,$3F,$3C,$3C,$3C,$3C,$00,$00,$C0,$E0,$F0,$F8,$7C,$3C,$00,$00
    !byte $F3,$F3,$F3,$FF,$00,$FF,$00,$00,$92,$92,$98,$FF,$00,$FF,$00,$00
    !byte $4C,$49,$C3,$FF,$00,$FF,$00,$00,$94,$F4,$94,$F4,$00,$F4,$00,$00
; ==============================================================================
                    *= sprite_data
                    !bin "gfx/sprites.bin"
; ==============================================================================
                    *= data_start
colram_data:
;     0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15  16  17  18  19  20  21  22  23  24  25  26  27  28  29  30  31  32  33  34  35  36  37  38  39
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 0
!by $00,$00,$00,$0A,$0A,$0E,$0E,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0A,$0A,$00,$00,$00
!by $00,$00,$00,$0A,$0A,$06,$06,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0A,$0A,$00,$00,$00
!by $00,$00,$00,$0A,$0A,$0E,$0E,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$0A,$0A,$06,$06,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$03,$03,$03,$0E,$03,$03,$03,$03,$03,$03,$03,$03,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 5
!by $00,$00,$00,$04,$04,$04,$06,$04,$04,$04,$04,$04,$04,$04,$04,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$0A,$0A,$0E,$0E,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$0A,$0A,$06,$06,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$0A,$0A,$0E,$0E,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$0A,$0A,$06,$06,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 10
!by $00,$00,$00,$0A,$0A,$0E,$0E,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0A,$0A,$00,$00,$00
!by $00,$00,$00,$0A,$0A,$06,$06,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0A,$0A,$00,$00,$00
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 15
!by $00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00
!by $00,$00,$00,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$00,$00,$00
!by $00,$00,$00,$05,$05,$05,$05,$05,$05,$05,$05,$05,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$07,$07,$07,$07,$00,$0F,$00,$0A,$0A,$0A,$0A,$0A,$00,$00,$00
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 20
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
!by $00,$00,$00,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$00,$00,$00
!by $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;     0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15  16  17  18  19  20  21  22  23  24  25  26  27  28  29  30  31  32  33  34  35  36  37  38  39

coltab0:
;       0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F
!byte $0a, $04, $0c, $03, $0d, $01, $0d, $03, $0c, $04, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0c, $0e, $04, $0b, $06, $0b, $04, $0e, $0c, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a ; 7
!byte $0a, $04, $0c, $03, $0d, $01, $0d, $03, $0c, $04, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0c, $0e, $04, $0b, $06, $0b, $04, $0e, $0c, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a
!byte $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a, $0a

